package xyz.lychee.lagfixer.libs.adventure.text;

import java.util.stream.Stream;
import xyz.lychee.lagfixer.libs.annotations.Contract;
import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.examination.ExaminableProperty;

public interface EntityNBTComponent extends NBTComponent<EntityNBTComponent, Builder>, ScopedComponent<EntityNBTComponent> {
   @NotNull String selector();

   @Contract(
      pure = true
   )
   @NotNull EntityNBTComponent selector(final @NotNull String selector);

   default @NotNull Stream<? extends ExaminableProperty> examinableProperties() {
      return Stream.concat(Stream.of(ExaminableProperty.of("selector", this.selector())), NBTComponent.super.examinableProperties());
   }

   public interface Builder extends NBTComponentBuilder<EntityNBTComponent, Builder> {
      @Contract("_ -> this")
      @NotNull
      @NotNull Builder selector(final @NotNull String selector);
   }
}
